unit OPTNClassic;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, PPControl;

type
  TOPTNClassicForm = class(TForm)
    COEMCharset: TCheckBox;
    CBlockNumbers: TCheckBox;
    BOK: TBitBtn;
    BCancel: TBitBtn;
    procedure BOKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FileName:string;
  end;

var
  OPTNClassicForm: TOPTNClassicForm;

implementation

{$R *.dfm}

procedure TOPTNClassicForm.BOKClick(Sender: TObject);
var fn_local:string; t:system.text;
    OEM:boolean; OEMBuf:array of char;
    Y,Y0,X0:integer;
begin
  if (length(PPGrid)<=0) OR (PPLegendMax<=0) then exit;
  OEM:=COEMCharset.Checked;
  if OEM then begin
    X0:=SizeX+3;
    if X0<length(PPLegendStr[0]) then X0:=length(PPLegendStr[0]);
    SetLength(OEMBuf,X0+4);
  end;
  if CBlockNumbers.Checked then begin Y0:=0; X0:=0; end
                           else begin Y0:=1; X0:=3; end;
  // PaperPic schreiben
  fn_local:=ChangeFileExt(FileName,'.pp1');
  AssignFile(t,fn_local); {$I-} Rewrite(t); {$I+}
  if IOResult<>0 then begin
    MessageDlg('Kann Datei'^M#34+fn_local+#34^M'nicht schreiben!',
               mtError,[mbOK],0);
    exit;
  end;
  for Y:=Y0 to SizeY do
    if OEM then begin
      CharToOem(@PPGrid[Y*PPGPitch+X0],@OEMBuf[0]);
      writeln(t,PChar(OEMBuf));
    end else
      writeln(t,PChar(@PPGrid[Y*PPGPitch+X0]));
  CloseFile(t);
  // Legende schreiben
  fn_local:=ChangeFileExt(FileName,'.ppl');
  AssignFile(t,fn_local); {$I-} Rewrite(t); {$I+}
  if IOResult<>0 then begin
    MessageDlg('Kann Datei'^M#34+fn_local+#34^M'nicht schreiben!',
               mtError,[mbOK],0);
    exit;
  end;
  writeln(t,'LEGENDE:');
  for Y:=0 to PPLegendMax do
    if OEM then begin
      CharToOem(PChar(PPLegendStr[Y]),@OEMBuf[0]);
      writeln(t,#32#32,PChar(OEMBuf));
    end else
      writeln(t,#32#32,PPLegendStr[Y]);
  CloseFile(t);
end;

end.
